"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../components/Styles/theme");
const Icon_1 = __importDefault(require("../Icon"));
const Touchable_1 = __importDefault(require("../Touchable"));
const Cell = props => {
    const { title, titleStyle = {}, label, border = true, centerRightText = true, rightContent, isLink = false, rightIconName = 'right', rightIconSize = 24, rightIconColor = '#7f7f7f', style, onPress, renderLeftIcon, } = props;
    return (react_1.default.createElement(Touchable_1.default, { style: [styles.container, border && styles.border, style], underlayColor: theme_1.Theme.fillBody, onPress: onPress },
        react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(react_native_1.View, { style: styles.left },
                react_1.default.createElement(react_native_1.View, { style: styles.titleWrap },
                    renderLeftIcon ? react_1.default.createElement(react_native_1.View, { style: styles.iconWrap }, renderLeftIcon()) : null,
                    react_1.default.createElement(react_native_1.Text, { style: [styles.titleText, titleStyle] }, title)),
                !!label && (react_1.default.createElement(react_native_1.View, { style: styles.titleLabelWrap },
                    react_1.default.createElement(react_native_1.Text, { numberOfLines: 1, style: styles.titleLabel }, label)))),
            react_1.default.createElement(react_native_1.View, { style: [styles.right, { alignSelf: centerRightText ? 'center' : 'flex-start' }] },
                !!rightContent && (react_1.isValidElement(rightContent) ? rightContent : react_1.default.createElement(react_native_1.Text, null, rightContent)),
                isLink && react_1.default.createElement(Icon_1.default, { name: rightIconName, size: rightIconSize, color: rightIconColor })))));
};
const styles = react_native_1.StyleSheet.create({
    container: {
        flexDirection: 'row',
        alignItems: 'center',
        paddingVertical: 12,
        paddingHorizontal: 10,
    },
    border: {
        borderBottomColor: theme_1.Theme.borderLightColor,
        borderBottomWidth: 0.5,
    },
    left: {
        flex: 1,
    },
    titleWrap: {
        flexDirection: 'row',
        alignItems: 'center',
    },
    iconWrap: {
        marginRight: 6,
    },
    titleText: {
        fontSize: 16,
        color: theme_1.Theme.colorTextParagraph,
    },
    titleLabelWrap: {
        marginTop: 4,
    },
    titleLabel: {
        fontSize: 12,
        color: theme_1.Theme.colorTextCaption,
    },
    right: {
        flexDirection: 'row',
        alignItems: 'center',
    },
});
exports.default = Cell;
