"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const Icon_1 = __importDefault(require("../Icon"));
const Touchable_1 = __importDefault(require("../Touchable"));
const theme_1 = require("../Styles/theme");
const Navbar = props => {
    const [left, setLeft] = react_1.useState(0);
    const [right, setRight] = react_1.useState(0);
    const { height = 42, title, titleSize = 17, titleColor = theme_1.Theme.colorTextParagraph, titleBold = false, showBack = false, backIconSize = 22, backIconColor = theme_1.Theme.colorTextParagraph, backIconName = 'left', backText = '', backTextStyle = {}, backgroundColor, barStyle = 'dark-content', showBorderBottom = true, renderLeft, renderRight, onBack, } = props;
    const onLeftLayout = (event) => {
        const { width } = event.nativeEvent.layout;
        setLeft(width);
    };
    const onRightLayout = (event) => {
        const { width } = event.nativeEvent.layout;
        setRight(width);
    };
    const statusBarHeight = react_native_1.StatusBar.currentHeight;
    // 取左右两边最大值，最小80
    const offset = Math.max(Math.max(left, right), 80);
    const statusBarStyle = {};
    if (backgroundColor) {
        statusBarStyle.backgroundColor = backgroundColor;
    }
    if (showBorderBottom) {
        statusBarStyle.borderBottomColor = theme_1.Theme.borderColor;
        statusBarStyle.borderBottomWidth = 0.5;
    }
    return (react_1.default.createElement(react_native_1.View, { style: statusBarStyle },
        react_1.default.createElement(react_native_1.StatusBar, { translucent: true, barStyle: barStyle, backgroundColor: "transparent" }),
        react_1.default.createElement(react_native_1.View, { style: { height: statusBarHeight } }),
        react_1.default.createElement(react_native_1.View, { style: { ...styles.container, height } },
            react_1.default.createElement(react_native_1.View, { onLayout: onLeftLayout }, renderLeft
                ? renderLeft()
                : showBack && (react_1.default.createElement(Touchable_1.default, { style: styles.backIconWrap, underlayColor: theme_1.Theme.fillBody, onPress: () => {
                        onBack && onBack();
                    }, hitSlop: 15 },
                    react_1.default.createElement(react_1.default.Fragment, null,
                        react_1.default.createElement(Icon_1.default, { name: backIconName, color: backIconColor, size: backIconSize }),
                        react_1.default.createElement(react_native_1.Text, { style: { ...styles.backText, ...backTextStyle } }, backText))))),
            react_1.default.createElement(react_native_1.Text, { style: {
                    ...styles.title,
                    left: offset,
                    right: offset,
                    color: titleColor,
                    fontSize: titleSize,
                    fontWeight: titleBold ? theme_1.FONT_WEIGHT.BOLD : theme_1.FONT_WEIGHT.NORMAL,
                }, numberOfLines: 1 }, title),
            renderRight && react_1.default.createElement(react_native_1.View, { onLayout: onRightLayout }, renderRight()))));
};
const styles = react_native_1.StyleSheet.create({
    container: {
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'center',
        paddingLeft: 6,
        paddingRight: 12,
    },
    backIconWrap: {
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'center',
        paddingVertical: 8,
        paddingHorizontal: 10,
        borderRadius: 10,
    },
    backText: {
        fontSize: 16,
        marginLeft: 2,
        color: theme_1.Theme.colorTextBase,
    },
    title: {
        flex: 1,
        textAlign: 'center',
        position: 'absolute',
    },
});
exports.default = Navbar;
