import { Component, ReactNode } from 'react';
import { ModalProps } from './modal';
export default class Modal extends Component<ModalProps> {
    /**
     *
     * @param title {string} 标题
     * @param content {string} 内容
     * @param options Omit<ModalProps, 'title' | 'content' | 'visible' | 'onConfirm' | 'onClose'> 配置项，参考Modal组件配置
     * @returns
     */
    static show(title: string, content: string | ReactNode, options?: Omit<ModalProps, 'title' | 'content' | 'visible' | 'onConfirm' | 'onClose'>): Promise<{
        confirm: boolean;
    }>;
    render(): JSX.Element;
}
