import React, { Component } from 'react';
import ModalHost from './modal';
import { portal } from '../Portal';
export default class Modal extends Component {
    /**
     *
     * @param title {string} 标题
     * @param content {string} 内容
     * @param options Omit<ModalProps, 'title' | 'content' | 'visible' | 'onConfirm' | 'onClose'> 配置项，参考Modal组件配置
     * @returns
     */
    static show(title, content, options = {}) {
        return new Promise(resolve => {
            const key = portal.add(React.createElement(ModalHost, Object.assign({}, options, { title: title, content: content, visible: true, onConfirm: () => {
                    portal.remove(key);
                    resolve({ confirm: true });
                }, onClose: () => {
                    portal.remove(key);
                    resolve({ confirm: false });
                } })));
        });
    }
    render() {
        return React.createElement(ModalHost, Object.assign({}, this.props));
    }
}
